#!/usr/bin/python
# Copyright 2009 Canonical Ltd.
#
# This file is part of wsgi-oops.
#
# wsgi-oops is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License version 3
# as published by the Free Software Foundation.
#
# wsgi-oops is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with wsgi-oops.  If not, see <http://www.gnu.org/licenses/>.

"""
Test Application for loading the Oops Middleware.
"""

import _pythonpath

from canonical.oops.wsgi import OopsWare
from storm.zope.zstorm import global_zstorm as zstorm

def app(environ, start_response):
    """this simple webserver has a few URLS to trigger test data for our opstats tool."""
    try:
        # TODO: Change this to an in-memory sqlite DB
        # that will also allow getting rid of zstorm.
        uri = 'postgres://%2Fhome%2Fdoctormo%2FCanonical%2FUbunet%2Ftrunk%2Ftmp%2Fdb/account'
        storm = zstorm.get('account', uri)
        storm.execute("select datname from pg_database;")
        start_response('200 OK', [('content-type', 'text/html')])
        raise ValueError, "Erk!"
        return ['Hehaw!']
    except:
        start_response('500 NOT OK', [('content-type', 'text/html')])
        return ['Avast!']


opstat_app = OopsWare(app, "dump/", debug=True)


if __name__ == '__main__':
    from paste import httpserver
    httpserver.serve(opstat_app, host='127.0.0.1', port='2112')



